# ironware_command – Run arbitrary commands on Extreme IronWare devices

New in version 2.5.

- Synopsis

- Parameters

- Notes

- Examples

- Return Values

- Status

## Synopsis

- Sends arbitrary commands to a Extreme Ironware node and returns the results read from the device. This module includes a wait_for argument that will cause the module to wait for a specific condition before returning or timing out if the condition is not met.

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---

authorize
boolean

Choices:
- no ←
- yes

Deprecated
Starting with Ansible 2.7 we recommend using `connection: network_cli` and `become: yes`.
For more information please see the IronWare Platform Options guide.

Instructs the module to enter privileged mode on the remote device before sending any commands. If not specified, the device will attempt to execute all commands in non-privileged mode. If the value is not specified in the task, the value of environment variable `ANSIBLE_NET_AUTHORIZE` will be used instead.

commands - / required |  | List of commands to send to the remote device over the configured provider. The resulting output from the command is returned. If the wait_for argument is provided, the module is not returned until the condition is satisfied or the number of retires as expired.
interval - | Default: 1 | Configures the interval in seconds to wait between retries of the command. If the command does not pass the specified conditions, the interval indicates how long to wait before trying the command again.

match
-

Choices:
- any
- all ←

The match argument is used in conjunction with the wait_for argument to specify the match policy. If the value is set to `all` then all conditionals in the wait_for must be satisfied. If the value is set to `any` then only one of the values must be satisfied.

provider
dictionary

Deprecated
Starting with Ansible 2.7 we recommend using `connection: network_cli` and `become: yes`.
For more information please see the IronWare Platform Options guide.

A dict object containing connection details.

| auth_pass string |  | Specifies the password to use if required to enter privileged mode on the remote device. If authorize is false, then this argument does nothing. If the value is not specified in the task, the value of environment variable `ANSIBLE_NET_AUTH_PASS` will be used instead.

authorize
boolean

Choices:
- no ←
- yes

Instructs the module to enter privileged mode on the remote device before sending any commands. If not specified, the device will attempt to execute all commands in non-privileged mode. If the value is not specified in the task, the value of environment variable `ANSIBLE_NET_AUTHORIZE` will be used instead.

| host string |  | Specifies the DNS host name or address for connecting to the remote device over the specified transport. The value of host is used as the destination address for the transport.
| password string |  | Specifies the password to use to authenticate the connection to the remote device. This value is used to authenticate the SSH session. If the value is not specified in the task, the value of environment variable `ANSIBLE_NET_PASSWORD` will be used instead.
| port integer | Default: 22 | Specifies the port to use when building the connection to the remote device.
| ssh_keyfile path |  | Specifies the SSH key to use to authenticate the connection to the remote device. This value is the path to the key used to authenticate the SSH session. If the value is not specified in the task, the value of environment variable `ANSIBLE_NET_SSH_KEYFILE` will be used instead.
| timeout integer | Default: 10 | Specifies idle timeout in seconds for the connection, in seconds. Useful if the console freezes before continuing. For example when saving configurations.
| username string |  | Configures the username to use to authenticate the connection to the remote device. This value is used to authenticate the SSH session. If the value is not specified in the task, the value of environment variable `ANSIBLE_NET_USERNAME` will be used instead.
retries - | Default: 10 | Specifies the number of retries a command should by tried before it is considered failed. The command is run on the target device every retry and evaluated against the wait_for conditions.
wait_for - |  | List of conditions to evaluate against the output of the command. The task will wait for each condition to be true before moving forward. If the conditional is not true within the configured number of retries, the task fails. See examples.

## Notes

Note

- For more information on using Ansible to manage network devices see the Ansible Network Guide

## Examples

    - ironware_command:
        commands:
          - show version

    - ironware_command:
        commands:
          - show interfaces brief wide
          - show mpls vll

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
failed_conditions list | failed | the conditionals that failed Sample: ['...', '...']
stdout list | always | the set of responses from the commands Sample: ['...', '...']
stdout_lines list | always | The value of stdout split into a list Sample: [['...', '...'], ['...'], ['...']]

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]

- This module is maintained by the Ansible Community. [community]

### Authors

- Paul Baker (@paulquack)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.